<template>
    <div class="home" >

        <div v-if="!rows">
            <div class="d-flex justify-content-center">
                <div class="text-center text-success my-2">
                    <b-spinner class="align-middle"></b-spinner>
                    <strong class="mx-2" >Carregando...</strong>
                </div>
            </div>
        </div>
        
        <div v-else>

            <b-pagination v-model="currentPage" pills align="center" :per-page="perPage" :total-rows="rows"></b-pagination>

            <p class="mt-3">Total de Serviços : {{rows}} | Pagina: {{ currentPage }}</p>

            <b-table striped hover small :fields="fields" :per-page="perPage" :current-page="currentPage" :items="items" responsive="sm" >

              <template #cell(etiqueta)="data">
                  <h1><strong>{{data.value}}</strong></h1>
                </template>

                <template #cell(envio)="data">
                    <b-badge v-if="data.value == 'false'" variant="danger">Pendente</b-badge> 
                    <b-badge v-else variant="success">{{data.value}}</b-badge>
                </template>

                <template #cell(codRastreio)="data">
                    <b-badge v-if="data.value == 'null'" variant="danger">Pendente</b-badge>
                    <b-badge v-else variant="success">{{data.value}}</b-badge>
                </template>

                <template #cell(dataInstalacao)="data">
                    <b-badge v-if="data.value == 'null'" variant="danger">Pendente</b-badge>
                    <b-badge v-else variant="success">{{data.value}}</b-badge>
                </template>

                 <template #cell(iniInstalacao)="data">
                    <b-badge v-if="data.value == 'null'" variant="danger">Pendente</b-badge>
                    <b-badge v-else variant="success">{{data.value}}</b-badge>
                </template>

                <template #cell(conclusao)="data">
                    <b-badge v-if="data.value == 'null'" variant="danger">Pendente</b-badge>
                    <b-badge v-else variant="success">{{data.value}}</b-badge>
                </template>

                <!-- <template #cell(id)="data">
                    <b-badge @click="attServico(data.value)" variant="primary">Atualizar</b-badge>
                </template> -->


            </b-table>

            <div>

                <b-modal id="modalStatus" :header-bg-variant="alert.bg" centered  :header-text-variant="alert.color" header-class='border-0 ' body-class='d-none' :title="alert.msg" hide-body  hide-footer>
                </b-modal>
            </div>

        </div>

    </div>
</template>

<script>
import axios from 'axios'
export default {
  name: 'Login',
  data(){
    return{
        perPage: 10,
        currentPage: 1,
        items: [],
        users: [],
        fields: [
          { key: 'etiqueta', label: 'Etiqueta' },
          { key: 'conclusao', label: 'Conclusao' }
        ],

        ////////////////////////
        
        userServico:{},
        userServicoBackup: {},

        alert: {
            bg: 'success',
            color: 'white',
            msg: 'Sucesso ao Cadastrar',
        },
        ///////////////////////////////////
        user : {
          id: null,
          name: null,
          email: null,
          senha: null,
          phone: null,
          cpf: null,
          type: null
        },

    }
  },
  computed: {
    rows() {
        return this.items.length
    }
  },
  methods:{
    getUser(){
      const _vn = this

      axios.get('https://7re2usa707.execute-api.us-east-1.amazonaws.com/production/user')
      .then(function (response) {
        // console.log(response.data)
        response.data.map(item => {
          item.id == _vn.user.id ? _vn.users = item : null
        })
        // console.log(_vn.user.id)
        _vn.getServico()
      })
      .catch(function (error) {
        console.log(error);
      });
    },
    getServico(){
      const _vn = this

      axios.get('https://7re2usa707.execute-api.us-east-1.amazonaws.com/production/servico')
      .then(function (response) {
        // console.log(response.data)

          response.data.map(item => {
            if(_vn.users.id == item.idUser){
             
              _vn.items.push({
                id             : item.id,
                idUser         : item.idUser,
                etiqueta       : item.etiqueta,
                name           : _vn.users.name,
                email          : _vn.users.email,
                phone          : _vn.users.phone,
                cpf            : _vn.users.cpf,
                envio          : item.envio,
                codRastreio    : item.codRastreio,
                dataInstalacao : item.dataInstalacao,
                iniInstalacao  : item.iniInstalacao,
                conclusao      : item.conclusao,
                timestamp      : item.timestamp
              })
              
            }
          })

        // console.log(_vn.items)
      })
      .catch(function (error) {
        console.log(error);
      });
    },
    hideModal(){
        this.items = []
        this.getUser()
        this.$bvModal.hide("modalServico")
    },
    checkLogin(){
      let login = localStorage.getItem('login')
      !login ? this.$router.push('/login') : this.insertUser()
    },
    insertUser(){
      let userBD = JSON.parse(localStorage.getItem('user'))
      this.user = {
        id: userBD.id,
        name: userBD.data.name,
        email: userBD.email,
        senha: userBD.senha,
        phone: userBD.data.phone,
        cpf: userBD.data.cpf,
        type: userBD.type
      }
      // console.log(this.user)
    }
  },
  mounted(){
    this.getUser()
    this.checkLogin()
  }
  
}
</script>

<style>
.home {
  height: calc(100vh - 145px);
}
table.table th, table.table td h1{
  font-size: 20px;
}
@media(max-width: 767px){
    table.table th, table.table td  {
         font-size: 12px;
    }
    table.table th, table.table td h1{
      font-size: 13 MMacOS
      px;
    }
}
</style>